//*********************************************************************************************
// forest.h
//*********************************************************************************************

#ifndef __FOREST_H__
#define __FOREST_H__

#pragma message("Compiling forest.h\n")

// Required header files
#include "component.h"
#undef _C

// Classes defined in this file
struct less_Forest;
class CForest;

// User-defined types
typedef set<CForest, less_Forest> Forest_set;

//----------------------------------------------------------------------------------------------

// Function object to order forests
struct less_Forest
{
  bool operator()(const CForest& F1, const CForest& F2) const;
};

//----------------------------------------------------------------------------------------------

// Forest: acyclic graph with component set _C
class CForest
{
 private:

  friend class CGraph;
  friend struct less_Forest;

  // List of pointers to constituent components
  vector<CComponent*> _C;
         
  CForest(const Component_set& C);
  CForest(const CForest& F, CComponent* old_c1, CComponent* old_c2, CComponent* new_c);
  
  bool operator<(const CForest& rhs) const;

  void report(void) const;
};

//----------------------------------------------------------------------------------------------

#endif
