//*********************************************************************************************
// permutation.h
//*********************************************************************************************

#ifndef __PERMUTATION_H__
#define __PERMUTATION_H__

#pragma message("Compiling permutation.h\n")

// User-defined types
typedef vector< vector<int> > DCN;

//----------------------------------------------------------------------------------------------

// Permutation gamma : [n] -> [n]
class CPermutation
{
 private:

  friend class CEdge;
  friend class CEdges;
  friend class CGraph;

  // Image of [n] under gamma: _image[x-1] = y :<=> gamma(x) = y
  vector<int> _image;

  // Buffer for gamma in disjoint cycle notation
  DCN _DCN;
  bool _DCN_available;

  CPermutation() : _DCN_available(false) {}
  CPermutation(int n);

  int permute(int x) const;

  void inverse(CPermutation& inv) const;

  bool is_id(void) const;

  void compute_DCN(void);

  void report(void);
};

//----------------------------------------------------------------------------------------------

#endif
