//*********************************************************************************************
// ratiostats.h
//*********************************************************************************************

#ifndef __RATIOSTATS_H__
#define __RATIOSTATS_H__

#pragma message("Compiling ratiostats.h\n")
#undef _n
#undef _N

class CGraph;

//----------------------------------------------------------------------------------------------

class CRatiostats
{
 private:
  friend class CGraph;

  int _n;
  int _N;

  vector<double> _mean;
  vector<double> _min;
  vector<double> _max;
  vector<int> _num_instances;
  vector<bool> _finalized;

  double _res;
  double _range_min;
  vector<int> _num_buckets;
  matrix<int> _histogram;

  ofstream *_buffer1;
  ofstream *_buffer2;

  vector<CGraph> _G_min;
  vector<CGraph> _G_max;

  CRatiostats(int n, int N, double res = 0.1, double range_min = 1.0, int E_i = -1);

  ~CRatiostats(void);

  void update(int s, double ratio, CGraph& G);

  void finalize(int l);

  void report(int l);

  void plot(int E_i = -1);
};

//----------------------------------------------------------------------------------------------

#endif
